/*
	$Id: DetachedItemException.java 6881 2015-04-21 07:59:42Z nicklas $

	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core;

/**
	This exception is thrown when trying to use an item 
	that has been detached from the {@link DbControl} that
	manages it.

	@author Nicklas
	@version 2.0
*/
public class DetachedItemException
	extends BaseException
{
	
	/**
		
	*/
	private static final long serialVersionUID = 4694041774316355349L;

	/**
		Creates a new <code>DetachedItemException</code>. The error
		message produced will look like:
		<code>Item is detached: User[ID=1]</code>

		@param what A description of what has been detached, for 
			example User[ID=1]
	*/
	public DetachedItemException(String what)
	{
		super("Item is detached: "+what);
	}
	

}



