/**
	$Id$

	Copyright (C) 2012 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.util.overview.extensions;

import net.sf.basedb.util.extensions.Action;
import net.sf.basedb.util.overview.Severity;
import net.sf.basedb.util.overview.Validator;

/**
	The same as a Validator. The Action interface provides the 
	possibility to link with the extension system.
	
	@author nicklas
	@since 3.2
	@see Validator
*/
public interface ValidationRuleAction
	extends Action
{

	
	/**
		Get the unique ID of this validation rule.
	*/
	public String getId();
	
	/**
		Get the title of this validator rule.
	*/
	public String getTitle();
	
	/**
		Get a lengthier description of the validation that takes place
	*/
	public String getDescription();
	
	/**
		Get a short summary that is displayed when the validation fails
	*/
	public String getFailureSummary();
	
	/**
		Get the default severity level.
	*/
	public Severity getDefaultSeverity();
	
	
}
