/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2013 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/

var Wizard = function()
{
	var wizard = {};
	
	/**
		Initialize the page.
	*/
	wizard.initCheckBoxes = function(element, autoInit)
	{
		if (autoInit == 'install')
		{
			Events.addEventHandler(element, 'click', wizard.installOnClick);
		}
		else if (autoInit == 'uninstall')
		{
			Events.addEventHandler(element, 'click', wizard.uninstallOnClick);
		}
		else if (autoInit == 'ignore')
		{
			Events.addEventHandler(element, 'click', wizard.ignoreOnClick);
		}
		else if (autoInit == 'stop-ignore')
		{
			Events.addEventHandler(element, 'click', wizard.stopIgnoreOnClick);
		}
	}
	Doc.addElementInitializer(wizard.initCheckBoxes);
	
	wizard.initPage = function()
	{
		// Save + Close buttons
		Buttons.addClickHandler('startScan', wizard.startManualScan);
		Buttons.addClickHandler('close', App.closeWindow);
	}
	
	wizard.installOnClick = function(event)
	{
		var frm = document.forms['scan'];
		var install = event.target;
		if (install.checked)
		{
			var uninstall = frm[install.name.replace(/\.install$/, '.uninstall')];
			if (uninstall) uninstall.checked = false;
			var ignore = frm[install.name.replace(/\.install$/, '.ignore')];
			if (ignore) ignore.checked = false;
			var stopIgnore = frm[install.name.replace(/\.install$/, '.stopignore')];
			if (stopIgnore) stopIgnore.checked = true;
		}
	}

	wizard.uninstallOnClick = function(event)
	{
		var frm = document.forms['scan'];
		var uninstall = event.target;
		if (uninstall.checked)
		{
			var install = frm[uninstall.name.replace(/\.uninstall$/, '.install')];
			if (install) install.checked = false;
		}
		else
		{
			var ignore = frm[uninstall.name.replace(/\.uninstall$/, '.ignore')];
			if (ignore) ignore.checked = false;
		}
	}
	
	wizard.ignoreOnClick = function(event)
	{
		var frm = document.forms['scan'];
		var ignore = event.target;
		if (ignore.checked)
		{
			var install = frm[ignore.name.replace(/\.ignore$/, '.install')];
			if (install) install.checked = false;
			var uninstall = frm[ignore.name.replace(/\.ignore$/, '.uninstall')];
			if (uninstall) uninstall.checked = true;
		}
	}

	wizard.stopIgnoreOnClick = function(event)
	{
		var frm = document.forms['scan'];
		var stopIgnore = event.target;
		if (!stopIgnore.checked)
		{
			var install = frm[stopIgnore.name.replace(/\.stopignore$/, '.install')];
			if (install) install.checked = false;
		}
	}
	
	wizard.startManualScan = function()
	{
		var frm = document.forms['scan'];
		frm.cmd.value = 'DoManualScan';
		frm.submit();
	}
	

	return wizard;
}();

Doc.onLoad(Wizard.initPage);
