<%-- $Id: list_items.jsp 7269 2017-01-11 12:48:14Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Nicklas Nordborg
	Copyright (C) 2007 Johan Enell, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.Removable"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.Ownable"
	import="net.sf.basedb.core.Shareable"
	import="net.sf.basedb.core.SharedItem"
	import="net.sf.basedb.core.Subtypable"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.Directory"
	import="net.sf.basedb.core.Metadata"
	import="net.sf.basedb.core.PropertyFilter"
	import="net.sf.basedb.core.query.ResultList"
	import="net.sf.basedb.core.query.Restriction"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.ReturnClassFilter"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.util.ShareableUtil"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ModeInfo"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.Iterator"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.SYSTEM;
	private static final String subContext = "allitems";

	private static final Enumeration<String, String> items = new Enumeration<String, String>();
	static
	{
		for (Item item : Metadata.getOwnableItems())
		{
			items.add(item.name(), item.toString());
		}
	}
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subContext, null, null);
final ModeInfo mode = ModeInfo.get(request.getParameter("mode"));
final DbControl dc = sc.newDbControl();
ResultList<Ownable> allItems = null;
try
{
	long totalCount = 0;
	try
	{
		String filterItem = cc.getPropertyValue("type");
		Set<Item> itemTypes = null;
		if (filterItem != null)
		{
			itemTypes = new HashSet<Item>();
			for (String name : filterItem.split("\\|"))
			{
				itemTypes.add(Item.valueOf(name));
			}
		}
		Restriction id = cc.getFilterRestriction("id", dc, null);
		Restriction sharedTo = Restrictions.conditionalRestriction(new ReturnClassFilter(Shareable.class),
			cc.getFilterRestriction("!sharedTo.name", dc, null), null, true);
		Restriction name = Restrictions.conditionalRestriction(new ReturnClassFilter(Nameable.class),
			cc.getFilterRestriction("name", dc, null), null, true);
		Restriction description = Restrictions.conditionalRestriction(new ReturnClassFilter(Nameable.class),
			cc.getFilterRestriction("description", dc, null), null, true);
		Restriction subtype = Restrictions.conditionalRestriction(new ReturnClassFilter(Subtypable.class),
			cc.getFilterRestriction("itemSubtype.name", dc, null), null, true);
		Restriction restriction = Restrictions.nullSafeAnd(sharedTo, name, description, id, subtype);

		User loggedInUser = User.getById(dc, sc.getLoggedInUserId());
		if (itemTypes == null || itemTypes.size() > 0)
		{
			allItems = loggedInUser.getItems(itemTypes, cc.getPage() * cc.getRowsPerPage(), 
					cc.getRowsPerPage(), null, restriction);
		}
		totalCount = allItems.getTotalCount();
	}
	catch (Throwable t)
	{
		cc.setMessage(t.getMessage());
	}
	int numListed = 0;
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext);
	ExtensionsInvoker invoker = ExtensionsControl.useExtensions(jspContext,  
			"net.sf.basedb.clients.web.toolbar.list.all", 
			"net.sf.basedb.clients.web.toolbar.list.allitems");
	ExtensionsInvoker columnsInvoker =  ExtensionsControl.useExtensions(jspContext, 
			"net.sf.basedb.clients.web.listcolumn.allitems");
	%>
	<base:page title="All items" id="list-page">
	<base:head scripts="table.js,~items.js" styles="table.css,toolbar.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	
	<base:body>
		<h1>All items</h1>
		<div class="content">
		<tbl:table 
			id="allItems" 
			columns="<%=cc.getSetting("columns")%>"
			action="index.jsp"
			sc="<%=sc%>"
			item="<%=itemType%>"
			subcontext="<%=subContext%>"
			subclass="fulltable"
			>
			<tbl:columndef
				id="type"
				property="type"
				datatype="string"
				title="Item type"
				enumeration="<%=items%>"
				filterable="true"
				show="always"
			/>
			<tbl:columndef 
				id="name"
				title="Name"
				property="name"
				filterable="true"
				datatype="string"
				show="always" 
			/>
			<tbl:columndef 
				id="id"
				property="id"
				datatype="int"
				title="ID"
				filterable="true"
			/>
			<tbl:columndef
				id="itemSubtype"
				property="itemSubtype.name"
				datatype="string"
				title="Subtype"
				filterable="true"
			/>
			<tbl:columndef 
				id="description"
				title="Description"
				property="description"
				filterable="true"
				datatype="string"
			/>
			<tbl:columndef
				id="sharedTo"
				title="Shared to"
				filterable="true"
				filterproperty="!sharedTo.name"
				datatype="string"
			/>
			<tbl:columndef 
				id="xt-columns" 
				extensions="<%=columnsInvoker%>" 
				jspcontext="<%=jspContext%>" 
			/>
			<div class="panelgroup bg-filled-50 bottomborder">
				<tbl:toolbar subclass="bottomborder">
					<tbl:button 
						id="btnDeleteItems"
						image="delete.png"
						title="Delete" 
						tooltip="Mark the selected items for deletion" 
						disabled="<%=totalCount <= 0%>"
					/>
					<tbl:button 
						id="btnRestoreItems"
						image="restore.png"
						title="Restore" 
						tooltip="Restore the selected items"
						disabled="<%=totalCount <= 0%>"
					/>
					<tbl:button 
						id="btnShareItems"
						image="share.png"
						title="Share&hellip;" 
						tooltip="Share the selected items"
						disabled="<%=totalCount <= 0%>"
					/>
					<tbl:button 
						id="btnSetOwner"
						image="take_ownership.png"
						title="Set owner&hellip;"
						tooltip="Change owner of the selected items"
					/>
					<tbl:button 
						id="btnColumns"
						image="columns.png" 
						title="Columns&hellip;" 
						tooltip="Show, hide and re-order columns" 
					/>
					<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
						wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
				</tbl:toolbar>
				<tbl:panel>
					<tbl:presetselector />
					<tbl:navigator
						page="<%=cc.getPage()%>" 
						rowsperpage="<%=cc.getRowsPerPage()%>" 
						totalrows="<%=allItems == null ? 0 : allItems.getTotalCount()%>"
					/>
				</tbl:panel>
			</div>
			<tbl:data>
				<tbl:headers>
					<tbl:headerrow>
						<tbl:header colspan="3" />
						<tbl:columnheaders />
					</tbl:headerrow>
					<tbl:headerrow>
						<tbl:header subclass="index" />
						<tbl:header 
							subclass="check" 
							><base:icon 
								subclass="link table-check"
								image="check_uncheck.png" 
								tooltip="Toggle all (use CTRL, ALT or SHIFT to check/uncheck)" 
								data-regexp="item:"
							/></tbl:header>
						<tbl:header 
							subclass="check" 
							visible="<%=mode.hasRadio()%>"
							/>
						<tbl:header 
							subclass="icons" 
							/>
						<tbl:propertyfilter />
					</tbl:headerrow>
				</tbl:headers>
				<tbl:rows>
					<%
					if (cc.getMessage() != null)
					{
						%>
						<tbl:panel subclass="bg-filled-50">
							<div class="messagecontainer error"><%=cc.getMessage()%></div>
						</tbl:panel>
						<%
						cc.setMessage(null);
					}
					int index = cc.getPage()*cc.getRowsPerPage();
					if (allItems != null)
					{
						for (Ownable item : allItems)
						{
							BasicItem basicItem = (BasicItem)item;
							boolean isRemoved = false;
							boolean isShared = false;
							boolean sharePermission = item.hasPermission(Permission.SET_PERMISSION);
							int itemId = item.getId();
							boolean deletePermission = item.hasPermission(Permission.DELETE);
							String name = "";
							String description = "";
							if (item instanceof File)
							{
								File file = (File)item;
								name = file.getPath().toString();
								description = file.getDescription();
							}
							else if (item instanceof Directory)
							{
								Directory dir = (Directory)item;
								name = dir.getPath().toString();
								description = dir.getDescription();
							}
							else if (item instanceof Nameable)
							{
								Nameable nameable = (Nameable)item;
								name = nameable.getName();
								description = nameable.getDescription();
							}
							else
							{
								name = item.toString();
							}
							if (item instanceof Removable)
							{
								isRemoved = ((Removable)item).isRemoved();
							}
							if (item instanceof Shareable)
							{
								isShared = ((Shareable)item).isShared();
							}
							String link = Base.getLink(ID, HTML.encodeTags(name), item.getType(), itemId, true);
							index++;
							numListed++;
							%>
							<tbl:row>
								<tbl:header 
									clazz="index"
									><%=index%></tbl:header>
								<tbl:header 
									clazz="check" 
									><input 
										type="checkbox" 
										name="item:<%=item.getType().name()%>" 
										value="<%=itemId%>"
									></tbl:header>
								<tbl:header 
									clazz="icons" 
									><base:icon 
										image="deleted.png"
										id="<%="delete."+itemId %>"
										subclass="<%=deletePermission ? "table-delete-item" : "disabled" %>"
										data-item-type="<%=item.getType().name()%>"
										data-item-id="<%=itemId%>"
										tooltip="This item has been marked for deletion" 
										visible="<%=isRemoved%>"
									/><base:icon 
										image="shared.png" 
										id="<%="share."+itemId %>"
										subclass="<%=sharePermission ? "table-share-item" : "disabled" %>"
										data-item-type="<%=item.getType().name()%>"
										data-item-id="<%=itemId%>"
										tooltip="This item is shared to other users, groups and/or projects" 
										visible="<%=isShared%>"
									/>&nbsp;</tbl:header>
								<tbl:cell column="type"><%=item.getType()%></tbl:cell>
								<tbl:cell column="name"><%=link%></tbl:cell>
								<tbl:cell column="id"><%=item.getId()%></tbl:cell>
								<tbl:cell column="itemSubtype"><%
								if (item instanceof Subtypable)
								{
									%><base:propertyvalue item="<%=item%>" property="itemSubtype" /><%
								}
								%></tbl:cell>
								<tbl:cell column="description"><%=HTML.encodeTags(description)%></tbl:cell>
								<tbl:cell column="sharedTo">
									<%
									if (item instanceof SharedItem)
									{
										Iterator<Nameable> sharees = ShareableUtil.getSharedTo(dc, (SharedItem)item).iterator();
										while(sharees.hasNext())
										{
											Nameable n = sharees.next();
											if (mode.hasPropertyLink())
											{
												out.write(Base.getLinkedName(ID, n, false, mode.hasEditLink()));
											}
											else
											{
												out.write(HTML.encodeTags(n.getName()));
											}
											out.write(sharees.hasNext() ? ", " : "");
										}
									}
									%>
								</tbl:cell>
								<tbl:xt-cells dc="<%=dc%>" item="<%=item%>">
									<tbl:cell column="xt-columns" />
								</tbl:xt-cells>
							</tbl:row>
							<%
							}
						}
					if (numListed == 0)
					{
						%>
						<tbl:panel subclass="bg-filled-50">
							<div class="messagecontainer note">
							<%=allItems == null || allItems.size() == 0 ? "No items were found" : "No items on this page. Please select another page!" %>
							</div>
						</tbl:panel>
						<%
					}
					%>
				</tbl:rows>
			</tbl:data>
		</tbl:table>
		</div>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
